## insighttoolkit 3.20.0

=== CMakeLists.txt ===
# This is the root ITK CMakeLists file.
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)


PROJECT(ITK)
INCLUDE_REGULAR_EXPRESSION("^([Nn]rrd|itk|vtk|vnl|vcl|vxl|v3p|f2c|netlib|ce|itpack|DICOM|meta|png|dbh|tif|jpeg|zlib|gdcm).*$")
SOURCE_GROUP("XML Files" REGULAR_EXPRESSION "[.]xml$")

# On Visual Studio 8 MS deprecated C. This removes all 1.276E1265 security
# warnings
IF(WIN32)
  IF(NOT BORLAND)
    IF(NOT CYGWIN)
      IF(NOT MINGW)
        IF(NOT ITK_ENABLE_VISUAL_STUDIO_DEPRECATED_C_WARNINGS)
          ADD_DEFINITIONS(
            -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
            -D_CRT_IS_WCTYPE_NO_DEPRECATE
            -D_CRT_MANAGED_FP_NO_DEPRECATE
            -D_CRT_NONSTDC_NO_DEPRECATE
            -D_CRT_SECURE_NO_DEPRECATE
            -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
            -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
            -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
            -D_CRT_VCCLRIT_NO_DEPRECATE
            -D_SCL_SECURE_NO_DEPRECATE
            )
        ENDIF(NOT ITK_ENABLE_VISUAL_STUDIO_DEPRECATED_C_WARNINGS)
      ENDIF(NOT MINGW)
    ENDIF(NOT CYGWIN)
  ENDIF(NOT BORLAND)
ENDIF(WIN32)


# If CMake is the version we're expecting, don't show the
# CMAKE_BACKWARDS_COMPATIBILITY option. If the version is higher than the
# minimal version required, then show the backward compatibility option.
IF("${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" MATCHES "^2\\.4$")
  MARK_AS_ADVANCED(FORCE CMAKE_BACKWARDS_COMPATIBILITY)
ELSE("${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" MATCHES "^2\\.4$")
  MARK_AS_ADVANCED(CLEAR CMAKE_BACKWARDS_COMPATIBILITY)
ENDIF("${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" MATCHES "^2\\.4$")

#-----------------------------------------------------------------------------
# ITK version number.  An even minor number corresponds to releases.
SET(ITK_VERSION_MAJOR "3")
SET(ITK_VERSION_MINOR "20")
SET(ITK_VERSION_PATCH "0")

# Version string should not include patch level.  The major.minor is
# enough to distinguish available features of the toolkit.
SET(ITK_VERSION_STRING "${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}")

#-----------------------------------------------------------------------------
# Load some macros.
INCLUDE(${ITK_SOURCE_DIR}/Utilities/itkThirdParty.cmake)

#-----------------------------------------------------------------------------
# Test for some required system information.
INCLUDE (${CMAKE_ROOT}/Modules/CMakeBackwardCompatibilityC.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CMakeBackwardCompatibilityCXX.cmake)

#-----------------------------------------------------------------------------
# Configure Dart testing support.  This should be done before any
# MESSAGE(FATAL_ERROR ...) commands are invoked.
INCLUDE(${CMAKE_ROOT}/Modules/Dart.cmake)
FIND_PACKAGE(Tclsh)
MARK_AS_ADVANCED(TCL_TCLSH DART_ROOT)
ENABLE_TESTING()
IF(BUILD_TESTING)
  CONFIGURE_FILE(${ITK_SOURCE_DIR}/CMake/RemoveTemporaryFiles.cmake.in
    ${ITK_BINARY_DIR}/CMake/RemoveTemporaryFiles.cmake @ONLY IMMEDIATE)
  CONFIGURE_FILE(${ITK_SOURCE_DIR}/CMake/itkSampleBuildTest.cmake.in
    ${ITK_BINARY_DIR}/CMake/itkSampleBuildTest.cmake @ONLY)
  CONFIGURE_FILE(${ITK_SOURCE_DIR}/CMake/CTestCustom.ctest.in
    ${ITK_BINARY_DIR}/CMake/CTestCustom.ctest @ONLY)
  CONFIGURE_FILE(${ITK_SOURCE_DIR}/CMake/CTestCustom.ctest.in
    ${ITK_BINARY_DIR}/Testing/Code/Common/CTestCustom.ctest @ONLY)
  FILE(WRITE ${ITK_BINARY_DIR}/CTestCustom.cmake
    "INCLUDE(\"${ITK_BINARY_DIR}/CMake/CTestCustom.ctest\")\n")

  CONFIGURE_FILE(${ITK_SOURCE_DIR}/InsightLogo.gif
                 ${ITK_BINARY_DIR}/Testing/HTML/TestingResults/Icons/Logo.gif
                 COPYONLY IMMEDIATE)
  SET(BUILDNAME "${BUILDNAME}" CACHE STRING "Name of build on the dashboard")
  MARK_AS_ADVANCED(BUILDNAME)
ENDIF(BUILD_TESTING)

#-----------------------------------------------------------------------------
# Output directories.
IF(NOT LIBRARY_OUTPUT_PATH)
  SET (LIBRARY_OUTPUT_PATH ${ITK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET (EXECUTABLE_OUTPUT_PATH ${ITK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)
MARK_AS_ADVANCED(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)

SET(ITK_LIBRARY_PATH "${LIBRARY_OUTPUT_PATH}")
SET(ITK_EXECUTABLE_PATH "${EXECUTABLE_OUTPUT_PATH}")
SET(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

SET(CMAKE_MODULE_PATH ${ITK_SOURCE_DIR}/CMake)
# Deal with FFT v3 Options
MARK_AS_ADVANCED(USE_FFTWD)
OPTION(USE_FFTWD "Use double precision FFTW if found" OFF)
MARK_AS_ADVANCED(USE_FFTWF)
OPTION(USE_FFTWF "Use single precision FFTW if found" OFF)
IF( USE_FFTWD OR USE_FFTWF )
  SET(msg "ATTENTION: You have enabled the use of FFTW,")
  SET(msg "${msg} this library is distributed under a GPL license.")
  SET(msg "${msg} By enabling this option, the binary of the ITK libraries")
  SET(msg "${msg} that you are going to build will be covered by a GPL license,")
  SET(msg "${msg} and so it will be any executable that you link against these libraries.")
  MESSAGE("${msg}")
  FIND_PACKAGE( FFTW )
ENDIF( USE_FFTWD OR USE_FFTWF )

# Deal with SGI SCSL Options
OPTION(USE_SCSL "Use the SGI SCSL High Performance Computing math library" OFF)
MARK_AS_ADVANCED(USE_SCSL)
IF( USE_SCSL )
    FIND_PACKAGE( SCSL )
ENDIF( USE_SCSL )

# Deal with MINC2 options
MARK_AS_ADVANCED(ITK_USE_MINC2)
OPTION(ITK_USE_MINC2 "Use MINC2 File Format" OFF)
IF( ITK_USE_MINC2 )
  FIND_PACKAGE( MINC2 )
  IF( NOT MINC2_FOUND )
    MESSAGE("You requested to use MINC2 but some components are missing")
  ENDIF( NOT MINC2_FOUND )
ENDIF( ITK_USE_MINC2 )


#-----------------------------------------------------------------------------
# ITK build configuration options.
OPTION(BUILD_SHARED_LIBS "Build ITK with shared libraries." OFF)
SET(ITK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

IF(NOT ITK_NO_LIBRARY_VERSION)
  # This setting of SOVERSION assumes that any API change
  # will increment either the minor or major version number of ITK.
  SET(ITK_LIBRARY_PROPERTIES 
      VERSION   "${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}.${ITK_VERSION_PATCH}"
      SOVERSION "${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}"
     )
ENDIF(NOT ITK_NO_LIBRARY_VERSION)

#-----------------------------------------------------------------------------
# Provide compatibility options.
OPTION(ITK_LEGACY_REMOVE "Remove all legacy code completely." OFF)
OPTION(ITK_LEGACY_SILENT "Silence all legacy code messages." OFF)
MARK_AS_ADVANCED(ITK_LEGACY_REMOVE ITK_LEGACY_SILENT)

SET(GDCM_LEGACY_SILENT ${ITK_LEGACY_SILENT})

#-----------------------------------------------------------------------------
# ITK build patented algorithms
OPTION(ITK_USE_PATENTED "Build algorithms that are covered with Patents. It is YOUR responsibility to obtain a license from the patent holder in order to use these methods." OFF)
MARK_AS_ADVANCED(ITK_USE_PATENTED)

#-----------------------------------------------------------------------------
# ITK build classes that are in the review process
OPTION(ITK_USE_REVIEW "Build algorithms that are candidates to be included in the Toolkit. This classes are not covered by the Backward Compatibility Policy, nor the Copyright Policy of ITK." OFF)
MARK_AS_ADVANCED(ITK_USE_REVIEW)

#-----------------------------------------------------------------------------
# ITK uses KWStyle for checking the coding style
INCLUDE(${ITK_SOURCE_DIR}/Utilities/KWStyle/KWStyle.cmake)

#-----------------------------------------------------------------------------
# ITK turn on concept checking
IF( NOT BORLAND )
  OPTION(ITK_USE_CONCEPT_CHECKING "Turn on concept checking to give helpful errors at compile time if a type cannot be used as a template parameter." ON)
  MARK_AS_ADVANCED(ITK_USE_CONCEPT_CHECKING)
  OPTION(ITK_USE_STRICT_CONCEPT_CHECKING "Turn on Strict concept checking to give more stringent errors at compile time if a type cannot be used as a template parameter." OFF)
  MARK_AS_ADVANCED(ITK_USE_STRICT_CONCEPT_CHECKING)
ELSE( NOT BORLAND )
  SET(ITK_USE_CONCEPT_CHECKING OFF)
  MARK_AS_ADVANCED(ITK_USE_CONCEPT_CHECKING)
  SET(ITK_USE_STRICT_CONCEPT_CHECKING OFF)
  MARK_AS_ADVANCED(ITK_USE_STRICT_CONCEPT_CHECKING)
ENDIF( NOT BORLAND )

#-----------------------------------------------------------------------------
# Make the itk::Image assume the behavior of the itk::OrientedImage
MARK_AS_ADVANCED(ITK_IMAGE_BEHAVES_AS_ORIENTED_IMAGE)
OPTION(ITK_IMAGE_BEHAVES_AS_ORIENTED_IMAGE "Makes itk::Image behave like itk::OrientedImage" ON)

# ITK turn on experimental version of accelerated image registration
OPTION(ITK_USE_OPTIMIZED_REGISTRATION_METHODS "Turn on the experimental version of accelerated registration methods." OFF)
MARK_AS_ADVANCED(ITK_USE_OPTIMIZED_REGISTRATION_METHODS)
IF(ITK_USE_OPTIMIZED_REGISTRATION_METHODS)
  IF(NOT ITK_USE_REVIEW)
    MESSAGE(FATAL_ERROR "ITK_USE_REVIEW is currently OFF but it should be ON if you want to use the experimental optimized registration methods.")
  ENDIF(NOT ITK_USE_REVIEW)
  # Warn the user about the implications of turning optimized registration methods ON
  SET(msg "Attention: You have chosen to enable the use of Optimized Registration Methods.")
  SET(msg "${msg} These methods add multi-threading capabilities to several image metrics")
  SET(msg "${msg} as well as some Transforms and Interpolators. In order to take full advantage")
  SET(msg "${msg} of these new features you will have to also add some new calls to these components.")
  SET(msg "${msg} Please look at the files in the Examples/Review directory for further details.")

# display the message during the setup
MESSAGE("${msg}")


ENDIF(ITK_USE_OPTIMIZED_REGISTRATION_METHODS)

#-----------------------------------------------------------------------------
# ITK use the new statistics framework
OPTION( ITK_USE_REVIEW_STATISTICS "Use the experimental statistics framework." OFF)
MARK_AS_ADVANCED( ITK_USE_REVIEW_STATISTICS )
IF(ITK_USE_REVIEW_STATISTICS)
  IF(NOT ITK_USE_REVIEW)
    MESSAGE(FATAL_ERROR "ITK_USE_REVIEW is currently OFF but it should be ON if you want to use the experimental statistics framework.")
  ENDIF(NOT ITK_USE_REVIEW)

  # Warn the user about the implications of using the new statistics framework.
  SET(msg "Attention: You have chosen to use the new statistics framework instead of the existing framework.")
  SET(msg "${msg} The statistics classes have been re-designed/refactored and in several")
  SET(msg "${msg} cases do not conform to the API of the older framework. You may need to")
  SET(msg "${msg} change your code to use the new API.")
  MESSAGE("${msg}")
ENDIF(ITK_USE_REVIEW_STATISTICS)

#-----------------------------------------------------------------------------
# ITK turn on experimental version of accelerated image registration
OPTION(ITK_USE_CONSOLIDATED_MORPHOLOGY "Turn on the experimental consolidated morphology." OFF)
MARK_AS_ADVANCED(ITK_USE_CONSOLIDATED_MORPHOLOGY)

IF(ITK_USE_CONSOLIDATED_MORPHOLOGY)
  IF(NOT ITK_USE_REVIEW)
    MESSAGE(FATAL_ERROR "ITK_USE_REVIEW is currently OFF but it should be ON if you want to use the experimental consolidated morphology.")
  ENDIF(NOT ITK_USE_REVIEW)
  # Warn the user about the implications of turning consolidated morphology ON
  SET(msg "Attention: You have chosen to enable the use of consolidated morphology.")
  # TODO: warn more than that
  # display the message during the setup
  MESSAGE("${msg}")
ENDIF(ITK_USE_CONSOLIDATED_MORPHOLOGY)


#-----------------------------------------------------------------------------
# ITK turn on the use of experimental IO factories for the TransformFileReader and TransformFileWriter
OPTION(ITK_USE_TRANSFORM_IO_FACTORIES "Turn on the experimental IO factories for reading and writing transforms." OFF)
MARK_AS_ADVANCED(ITK_USE_TRANSFORM_IO_FACTORIES)
IF(ITK_USE_TRANSFORM_IO_FACTORIES)
  IF(NOT ITK_USE_REVIEW)

=== Utilities/MetaIO/CMakeLists.txt ===
#=============================================================================
# MetaIO
# Copyright 2000-2010 Insight Software Consortium
#
# Distributed under the OSI-approved BSD License (the "License");
# see accompanying file Copyright.txt for details.
#
# This software is distributed WITHOUT ANY WARRANTY; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the License for more information.
#=============================================================================
IF(VTK_VERSION)
  SET(METAIO_FOR_VTK 1)
  MARK_AS_ADVANCED( METAIO_FOR_VTK )
  SET(METAIO_NAMESPACE "vtkmetaio")
ELSE(VTK_VERSION)
  SET(METAIO_FOR_ITK 1)
  MARK_AS_ADVANCED( METAIO_FOR_ITK )
  SET(METAIO_NAMESPACE "ITKMetaIO")

  IF(ITK_USE_LIBXML2)
    ADD_DEFINITIONS(-DMETAIO_USE_LIBXML2)
    INCLUDE_DIRECTORIES(${ITK_LIBXML2_INCLUDE_DIR})
  ENDIF(ITK_USE_LIBXML2)

ENDIF(VTK_VERSION)

PROJECT( ${METAIO_NAMESPACE} )

INCLUDE_DIRECTORIES(${${METAIO_NAMESPACE}_SOURCE_DIR})

ADD_LIBRARY(${METAIO_NAMESPACE}
  metaTypes.h
  metaUtils.cxx
  metaArrow.cxx
  metaBlob.cxx
  metaCommand.h
  metaCommand.cxx
  metaContour.h
  metaContour.cxx
  metaDTITube.cxx
  metaEllipse.cxx
  metaGroup.cxx
  metaGaussian.cxx
  metaImage.cxx
  metaImageUtils.cxx
  metaLandmark.cxx
  metaLine.cxx
  metaMesh.cxx
  metaMesh.h
  metaObject.cxx
  metaOutput.h
  metaOutput.cxx
  metaScene.cxx
  metaSurface.cxx
  metaTube.cxx
  metaVesselTube.cxx
  metaTransform.cxx
  metaTubeGraph.cxx
  metaForm.h
  metaForm.cxx
  metaArray.h
  metaArray.cxx
)

INCLUDE_REGULAR_EXPRESSION("^.*$")

# Need nsl to resolve gethostbyname on SunOS-5.8
# and socket also
IF(CMAKE_SYSTEM MATCHES "SunOS.*")
  TARGET_LINK_LIBRARIES(${METAIO_NAMESPACE} socket nsl)
ENDIF(CMAKE_SYSTEM MATCHES "SunOS.*") 

IF(METAIO_FOR_VTK)
  IF(BUILD_SHARED_LIBS)
    ADD_DEFINITIONS(-Dvtkmetaio_BUILD_SHARED_LIBS)
  ENDIF(BUILD_SHARED_LIBS)
  TARGET_LINK_LIBRARIES(${METAIO_NAMESPACE} ${VTK_ZLIB_LIBRARIES}
                                            ${KWSYS_NAMESPACE})
  IF(VTK_LIBRARY_PROPERTIES)
    SET_TARGET_PROPERTIES(${METAIO_NAMESPACE} 
                          PROPERTIES ${VTK_LIBRARY_PROPERTIES})
  ENDIF(VTK_LIBRARY_PROPERTIES)
ELSE(METAIO_FOR_VTK)
  IF(METAIO_FOR_ITK)
    TARGET_LINK_LIBRARIES(${METAIO_NAMESPACE} ${ITK_ZLIB_LIBRARIES} 
                                              ${KWSYS_NAMESPACE})
    IF(ITK_USE_LIBXML2)    
      TARGET_LINK_LIBRARIES(${METAIO_NAMESPACE} ${ITK_LIBXML2_LIBRARIES})
    ENDIF(ITK_USE_LIBXML2)   

    IF(ITK_LIBRARY_PROPERTIES)
      SET_TARGET_PROPERTIES(${METAIO_NAMESPACE} 
                            PROPERTIES ${ITK_LIBRARY_PROPERTIES})
    ENDIF(ITK_LIBRARY_PROPERTIES)
  ELSE(METAIO_FOR_ITK)
    TARGET_LINK_LIBRARIES(${METAIO_NAMESPACE} ${ZLIB_LIBRARIES}
                                              ${KWSYS_NAMESPACE})
  ENDIF(METAIO_FOR_ITK)
ENDIF(METAIO_FOR_VTK)

IF(WIN32)
  IF(BORLAND)
    TARGET_LINK_LIBRARIES(${METAIO_NAMESPACE} import32)
  ELSE(BORLAND)
    TARGET_LINK_LIBRARIES(${METAIO_NAMESPACE} comctl32 wsock32)
  ENDIF(BORLAND)
ENDIF(WIN32)


#SUBDIRS(tests)

IF(METAIO_FOR_VTK)
  IF(NOT VTK_INSTALL_NO_LIBRARIES)
    INSTALL(TARGETS ${METAIO_NAMESPACE}
            RUNTIME DESTINATION ${VTK_INSTALL_BIN_DIR_CM24} 
                    COMPONENT RuntimeLibraries
            LIBRARY DESTINATION ${VTK_INSTALL_LIB_DIR_CM24} 
                    COMPONENT RuntimeLibraries
            ARCHIVE DESTINATION ${VTK_INSTALL_LIB_DIR_CM24} 
                    COMPONENT Development
            )
    #TODO: Install Copyright.txt
    #INSTALL(FILES Copyright.txt
    #        DESTINATION ${VTK_INSTALL_DOC_DIR_CM24}/vtkmetaio
    #        COMPONENT RuntimeLibraries)
  ENDIF(NOT VTK_INSTALL_NO_LIBRARIES)
  IF(NOT VTK_INSTALL_NO_DEVELOPMENT)
    FILE(GLOB __files "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
    INSTALL(FILES ${__files}
                  DESTINATION ${VTK_INSTALL_INCLUDE_DIR_CM24}/vtkmetaio
                  COMPONENT Development)
  ENDIF(NOT VTK_INSTALL_NO_DEVELOPMENT)
ELSE(METAIO_FOR_VTK)
  IF(METAIO_FOR_ITK)
    IF(NOT ITK_INSTALL_NO_LIBRARIES)
      INSTALL(TARGETS ${METAIO_NAMESPACE}
              RUNTIME DESTINATION ${ITK_INSTALL_BIN_DIR_CM24} 
                      COMPONENT RuntimeLibraries
              LIBRARY DESTINATION ${ITK_INSTALL_LIB_DIR_CM24} 
                      COMPONENT RuntimeLibraries
              ARCHIVE DESTINATION ${ITK_INSTALL_LIB_DIR_CM24} 
                      COMPONENT Development
              )
      #TODO: Install Copyright.txt
    ENDIF(NOT ITK_INSTALL_NO_LIBRARIES)
    IF(NOT ITK_INSTALL_NO_DEVELOPMENT)
      FILE(GLOB __files "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
      INSTALL(FILES ${__files}
              DESTINATION ${ITK_INSTALL_INCLUDE_DIR_CM24}/Utilities/MetaIO
                          COMPONENT Development)
    ENDIF(NOT ITK_INSTALL_NO_DEVELOPMENT)
  ELSE(METAIO_FOR_ITK)
    STRING(REGEX REPLACE "^/" "" INSTALL_LIB_DIR_CM24 "${INSTALL_LIB_DIR}")
    STRING(REGEX REPLACE "^/" "" INSTALL_BIN_DIR_CM24 "${INSTALL_BIN_DIR}")
    STRING(REGEX REPLACE "^/" "" INSTALL_INCLUDE_DIR_CM24 
           "${INSTALL_INCLUDE_DIR}")
    INSTALL(TARGETS ${METAIO_NAMESPACE}
            RUNTIME DESTINATION ${INSTALL_BIN_DIR_CM24} 
                    COMPONENT RuntimeLibraries
            LIBRARY DESTINATION ${INSTALL_LIB_DIR_CM24} 
                    COMPONENT RuntimeLibraries
            ARCHIVE DESTINATION ${INSTALL_LIB_DIR_CM24} 
                    COMPONENT Development
            )
    #TODO: Install Copyright.txt
    FILE(GLOB __files "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
    INSTALL(FILES ${__files}
                  DESTINATION ${INSTALL_INCLUDE_DIR_CM24}/kwMetaIO
                  COMPONENT Development)
  ENDIF(METAIO_FOR_ITK)
ENDIF(METAIO_FOR_VTK)

=== Testing/Code/Review/CMakeLists.txt ===
IF( NOT ITK_DISABLE_CXX_TESTING )
IF(ITK_BINARY_DIR)
  IF(TCL_TCLSH)
    ADD_TEST(PrintSelf-Review ${TCL_TCLSH}
             ${ITK_SOURCE_DIR}/Utilities/Dart/PrintSelfCheck.tcl
             ${ITK_SOURCE_DIR}/Code/Review)
  ENDIF(TCL_TCLSH)
ENDIF(ITK_BINARY_DIR)


SET(REVIEW_TESTS ${CXX_TEST_PATH}/itkReviewTests)
SET(REVIEW_TESTS2 ${CXX_TEST_PATH}/itkReviewTests2)
SET(REVIEW_TESTS3 ${CXX_TEST_PATH}/itkReviewTests3)
SET(REVIEW_TESTS4 ${CXX_TEST_PATH}/itkReviewTests4)
SET(REVIEW_TESTS5 ${CXX_TEST_PATH}/itkReviewTests5)
SET(REVIEW_TESTS6 ${CXX_TEST_PATH}/itkReviewTests6)
SET(REVIEW_PRINT_TEST ${CXX_TEST_PATH}/itkReviewPrintTest)
SET(REVIEW_HEADER_TESTS ${CXX_TEST_PATH}/itkReviewHeaderTest)

ADD_TEST(itkReviewPrintTest ${REVIEW_PRINT_TEST})

SET(BASELINE ${ITK_DATA_ROOT}/Baseline/Review)
SET(INPUTDATA ${ITK_DATA_ROOT}/Input)
SET(BASELINE_ROOT ${ITK_DATA_ROOT}/Baseline)
SET(TEMP ${ITKTesting_BINARY_DIR}/Temporary)

INCLUDE_DIRECTORIES(
  # This directory is needed to find the itkFilterWatcher.h
  ${ITK_SOURCE_DIR}/Testing/Code/Algorithms
  # This directory is needed to find the itkTestingMacros.h
  ${ITK_SOURCE_DIR}/Testing/Code/Review
  )

#
#  List of Tests in this directory
#

SET(ReviewTest_SRCS
  itkFlatStructuringElementTest.cxx

  itkLabelToRGBImageFilterTest.cxx
  itkLabelOverlayImageFilterTest.cxx

  itkValuedRegionalMinimaImageFilterTest.cxx
  itkValuedRegionalMaximaImageFilterTest.cxx
  itkRegionalMaximaImageFilterTest.cxx
  itkRegionalMaximaImageFilterTest2.cxx
  itkRegionalMinimaImageFilterTest.cxx
  itkRegionalMinimaImageFilterTest2.cxx

  itkNeuralNetworkIOTest.cxx

  itkConformalFlatteningMeshFilterTest.cxx
  itkConformalFlatteningQuadEdgeMeshFilterTest.cxx

  itkVTKPolyDataIOQuadEdgeMeshTest.cxx
  itkVTKPolyDataReaderQuadEdgeMeshTest.cxx
  itkVTKPolyDataReaderTest.cxx
  itkVTKPolyDataWriterTest.cxx
  itkVTKPolyDataWriterTest2.cxx

  itkMorphologicalWatershedImageFilterTest.cxx
  itkMorphologicalWatershedFromMarkersImageFilterTest.cxx

  itkBinaryMorphologicalClosingImageFilterTest.cxx
  itkBinaryMorphologicalOpeningImageFilterTest.cxx

  itkOptImageToImageMetricsTest.cxx
  itkOptMattesMutualInformationImageToImageMetricThreadsTest1.cxx

  itkTimeAndMemoryProbeTest.cxx

  itkBruker2DSEQImageIOTest.cxx
  itkPhilipsRECImageIOTest.cxx

  itkVoxBoCUBImageIOTest.cxx

  itkSliceBySliceImageFilterTest.cxx

  itkDiffeomorphicDemonsRegistrationFilterTest.cxx
  itkDiffeomorphicDemonsRegistrationFilterTest2.cxx

  itkMultiplyByConstantImageFilterTest.cxx
  itkDivideByConstantImageFilterTest.cxx
  itkAddConstantToImageFilterTest.cxx
  itkSubtractConstantFromImageFilterTest.cxx

  itkImageReadComplexWriteMagnitudeAndPhaseTest.cxx
  itkImageReadMagnitudeAndPhaseWriteComplexTest.cxx
  itkImageReadRealAndImaginaryWriteComplexTest.cxx

  itkFFTComplexToComplexImageFilterTest01.cxx
  itkFFTComplexToComplexImageFilterTest02.cxx

  itkVectorLinearInterpolateNearestNeighborExtrapolateImageFunctionTest.cxx
  itkVectorCentralDifferenceImageFunctionTest.cxx
  itkExponentialDeformationFieldImageFilterTest.cxx
  itkFastSymmetricForcesDemonsRegistrationFilterTest.cxx
  itkGridForwardWarpImageFilterTest.cxx
  itkWarpHarmonicEnergyCalculatorTest.cxx

  itkBSplineScatteredDataPointSetToImageFilterTest.cxx
  itkBSplineScatteredDataPointSetToImageFilterTest2.cxx
  itkBSplineScatteredDataPointSetToImageFilterTest3.cxx

  itkCoxDeBoorBSplineKernelFunctionTest.cxx
  itkCoxDeBoorBSplineKernelFunctionTest2.cxx

  itkKappaSigmaThresholdImageCalculatorTest.cxx
  itkKappaSigmaThresholdImageFilterTest.cxx

  itkComposeRGBAImageFilterTest.cxx

  itkTransformToDeformationFieldSourceTest.cxx
  itkTransformToDeformationFieldSourceTest1.cxx
  
  itkBoxMeanImageFilterTest.cxx
  itkBoxSigmaImageFilterTest.cxx
  itkRankImageFilterTest.cxx
  itkMapRankImageFilterTest.cxx
  itkMaskedRankImageFilterTest.cxx
  itkMapMaskedRankImageFilterTest.cxx
  itkFastApproximateRankImageFilterTest.cxx
  
  itkDiscreteGaussianDerivativeImageFunctionTest.cxx
  itkDiscreteGradientMagnitudeGaussianImageFunctionTest.cxx
  itkDiscreteHessianGaussianImageFunctionTest.cxx
  
  itkBinaryContourImageFilterTest.cxx
  itkLabelContourImageFilterTest.cxx
  
  itkFFTShiftImageFilterTest.cxx

  itkConvolutionImageFilterTest.cxx
  itkConvolutionImageFilterTestInt.cxx

  itkShapedFloodFilledImageFunctionConditionalConstIteratorTest1.cxx
  itkShapedFloodFilledImageFunctionConditionalConstIteratorTest2.cxx
  itkShapedFloodFilledImageFunctionConditionalConstIteratorTest3.cxx

  itkRobustAutomaticThresholdImageFilterTest.cxx

  itkAreaOpeningImageFilterTest.cxx
  itkAreaClosingImageFilterTest.cxx

  itkHessianToObjectnessMeasureImageFilterTest.cxx
  itkMultiScaleHessianBasedMeasureImageFilterTest.cxx
)

SET(ReviewTest2_SRCS
  itkDirectFourierReconstructionImageToImageFilterTest.cxx
  itkBSplineDeformableTransformInitializerTest1.cxx
  itkBSplineDeformableTransformInitializerTest2.cxx
  itkHeavisideStepFunctionTest1.cxx
  itkLabelImageToLabelMapFilterTest.cxx 
  itkLabelMapFilterTest.cxx 
  itkLabelMapTest.cxx 
  itkLabelMapToLabelImageFilterTest.cxx 
  itkLabelObjectLineComparatorTest.cxx 
  itkLabelObjectLineTest.cxx 
  itkLabelObjectTest.cxx 
  itkMultiphaseFiniteDifferenceImageFilterTest.cxx 
  itkMultiphaseDenseFiniteDifferenceImageFilterTest.cxx 
  itkMultiphaseSparseFiniteDifferenceImageFilterTest.cxx 
  itkMultiScaleHessianBasedMeasureImageFilterTest.cxx
  itkQuadEdgem_NoPointTest.cxx
  itkQuadEdgeTest1.cxx
  itkGeometricalQuadEdgeTest1.cxx
  itkQuadEdgeMeshAddFaceTest1.cxx
  itkQuadEdgeMeshAddFaceTest2.cxx
  itkQuadEdgeMeshBasicLayerTest.cxx
  itkQuadEdgeMeshDeleteEdgeTest.cxx
  itkQuadEdgeMeshFrontIteratorTest.cxx
  itkQuadEdgeMeshIteratorTest.cxx
  itkQuadEdgeMeshPointTest1.cxx
  itkQuadEdgeMeshTest1.cxx
  itkQuadEdgeMeshTest2.cxx
  itkQuadEdgeMeshTest3.cxx
  itkQuadEdgeMeshEulerOperatorFlipTest.cxx
  itkQuadEdgeMeshEulerOperatorSplitVertexTest.cxx
  itkQuadEdgeMeshEulerOperatorJoinVertexTest.cxx
  itkQuadEdgeMeshEulerOperatorCreateCenterVertexTest.cxx
  itkQuadEdgeMeshEulerOperatorDeleteCenterVertexTest.cxx
  itkQuadEdgeMeshEulerOperatorJoinFacetTest.cxx
  itkQuadEdgeMeshEulerOperatorSplitEdgeTest.cxx
  itkQuadEdgeMeshEulerOperatorSplitFaceTest.cxx
  itkQuadEdgeMeshCellInterfaceTest.cxx
  itkQuadEdgeMeshPolygonCellTest.cxx
  itkDynamicQuadEdgeMeshTest.cxx
  itkAutomaticTopologyQuadEdgeMeshSourceTest.cxx
  itkRegularSphereQuadEdgeMeshSourceTest.cxx
  itkQuadEdgeMeshCountingCellsTest.cxx
  itkQuadEdgeMeshDeletePointAndReorderIDsTest.cxx
  itkBinaryMask3DQuadEdgeMeshSourceTest.cxx
  itkContourExtractor2DImageFilterTest.cxx
  itkTriangleHelperTest.cxx
  itkCrossHelperTest.cxx
  itkQuadEdgeMeshLinearParameterizationTest.cxx
  itkPriorityQueueTest.cxx
  itkQuadEdgeMeshSquaredEdgeLengthDecimationTest.cxx
  itkQuadEdgeMeshQuadricDecimationTest.cxx
  itkQuadEdgeMeshCleanFilterTest.cxx
  itkQuadEdgeMeshGaussianCurvatureTest.cxx
  itkQuadEdgeMeshMaxCurvatureTest.cxx
  itkQuadEdgeMeshMeanCurvatureTest.cxx
  itkQuadEdgeMeshMinCurvatureTest.cxx
  itkQuadEdgeMeshDelaunayConformingFilterTest.cxx
  itkQuadEdgeMeshNormalFilterTest.cxx
  itkQuadEdgeMeshSmoothingTest.cxx
  itkQuadEdgeMeshScalarDataVTKPolyDataWriterTest1.cxx
  itkAtanRegularizedHeavisideStepFunctionTest1.cxx
  itkRegionBasedLevelSetFunctionTest.cxx
  itkScalarRegionBasedLevelSetFunctionTest.cxx
  itkScalarToRGBColormapImageFilterTest.cxx
  itkStochasticFractalDimensionImageFilterTest.cxx
  itkSinRegularizedHeavisideStepFunctionTest1.cxx
)

SET(ReviewTest3_SRCS
  itkAggregateLabelMapFilterTest.cxx
  itkGridImageSourceTest.cxx
  itkTriangleMeshToBinaryImageFilterTest3.cxx

  itkBinaryImageToLabelMapFilterTest.cxx
  itkLabelMapToBinaryImageFilterTest.cxx
  itkChangeLabelLabelMapFilterTest.cxx
  itkRelabelLabelMapFilterTest1.cxx
  itkShiftScaleLabelMapFilterTest1.cxx
  itkAutoCropLabelMapFilterTest1.cxx
  itkChangeRegionLabelMapFilterTest1.cxx

  itkMergeLabelMapFilterTest1.cxx
  itkCropLabelMapFilterTest1.cxx
  itkPadLabelMapFilterTest1.cxx
  itkRegionFromReferenceLabelMapFilterTest1.cxx

  itkBinaryImageToShapeLabelMapFilterTest1.cxx
  itkLabelImageToShapeLabelMapFilterTest1.cxx

  itkShapeKeepNObjectsLabelMapFilterTest1.cxx
  itkShapeOpeningLabelMapFilterTest1.cxx
  itkShapeRelabelLabelMapFilterTest1.cxx
  itkBinaryShapeOpeningImageFilterTest1.cxx
  itkShapeLabelObjectAccessorsTest1.cxx
  itkBinaryShapeKeepNObjectsImageFilterTest1.cxx
  itkShapeRelabelImageFilterTest1.cxx
  itkLabelShapeKeepNObjectsImageFilterTest1.cxx
  itkLabelShapeOpeningImageFilterTest1.cxx
  itkShapeUniqueLabelMapFilterTest1.cxx

  itkGaborImageSourceTest.cxx

  itkDiscreteGaussianDerivativeImageFilterTest
)

SET(ReviewTest4_SRCS
  itkBinaryImageToStatisticsLabelMapFilterTest1.cxx
  itkLabelImageToStatisticsLabelMapFilterTest1.cxx
  itkStatisticsOpeningLabelMapFilterTest1.cxx
  itkStatisticsKeepNObjectsLabelMapFilterTest1.cxx
  itkStatisticsRelabelLabelMapFilterTest1.cxx
  itkBinaryStatisticsOpeningImageFilterTest1.cxx
  itkBinaryStatisticsKeepNObjectsImageFilterTest1.cxx
  itkLabelStatisticsKeepNObjectsImageFilterTest1.cxx
  itkLabelStatisticsOpeningImageFilterTest1.cxx
  itkStatisticsRelabelImageFilterTest1.cxx
  itkStatisticsUniqueLabelMapFilterTest1.cxx
)

SET(ReviewTest5_SRCS
  itkLabelGeometryImageFilterTest.cxx
  itkMRCImageIOTest.cxx
  itkVTKImageIO2Test.cxx
)

SET(ReviewTest6_SRCS
  itkScalarChanAndVeseLevelSetFunctionTest1.cxx
  itkScalarChanAndVeseLevelSetFunctionTest2.cxx
  itkScalarChanAndVeseDenseLevelSetImageFilterTest1.cxx
  itkScalarChanAndVeseDenseLevelSetImageFilterTest2.cxx
  itkScalarChanAndVeseDenseLevelSetImageFilterTest3.cxx
  itkScalarChanAndVeseDenseLevelSetImageFilterTest4.cxx
  itkScalarChanAndVeseSparseLevelSetImageFilterTest1.cxx
  itkScalarChanAndVeseSparseLevelSetImageFilterTest2.cxx
)

IF(ITK_USE_TRANSFORM_IO_FACTORIES)
  SET(ReviewTest_SRCS ${ReviewTest_SRCS} itkTransformFileReaderWriterTest.cxx)

  ADD_TEST(itkTransformFileReaderWriterTest0
    ${REVIEW_TESTS} itkTransformFileReaderWriterTest
    ${INPUTDATA}/itkAffineTransform00.txt
    ${TEMP}/itkTransformFileReaderWriterTest0.txt
    )

  ADD_TEST(itkTransformFileReaderWriterTest1
    ${REVIEW_TESTS} itkTransformFileReaderWriterTest
    ${INPUTDATA}/itkAffineTransform01.txt
    ${TEMP}/itkTransformFileReaderWriterTest1.txt
    )
  ADD_TEST(itkTransformFileReaderWriterTest2
    ${REVIEW_TESTS} itkTransformFileReaderWriterTest
    ${INPUTDATA}/itkAffineTransform01.txt
    ${TEMP}/itkTransformFileReaderWriterTest1.mat
    )
  ADD_TEST(itkTransformFileReaderWriterTest3
    ${REVIEW_TESTS} itkTransformFileReaderWriterTest
    ${INPUTDATA}/itkBSplineTransform00.txt
    ${TEMP}/itkBSplineTransform00.mat
    )
ENDIF(ITK_USE_TRANSFORM_IO_FACTORIES)

ADD_TEST(itkOptImageToImageMetricsTest01
  ${REVIEW_TESTS} itkOptImageToImageMetricsTest
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  )

ADD_TEST(itkOptImageToImageMetricsTest02
  ${REVIEW_TESTS}
  --with-threads 2
  itkOptImageToImageMetricsTest
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  )

ADD_TEST(itkOptImageToImageMetricsTest03
  ${REVIEW_TESTS}
  --without-threads
  itkOptImageToImageMetricsTest
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  ${ITK_SOURCE_DIR}/Examples/Data/BrainProtonDensitySliceBorder20.png
  )

IF(ITK_USE_OPTIMIZED_REGISTRATION_METHODS)
SET(ReviewTest_SRCS ${ReviewTest_SRCS} itkOptImageToImageMetricsTest2.cxx)
ADD_TEST(itkOptImageToImageMetricsTest04
  ${REVIEW_TESTS} itkOptImageToImageMetricsTest2
  ${ITK_SOURCE_DIR}/Examples/Data/DiagonalLines.png
  ${ITK_SOURCE_DIR}/Testing/Data/Baseline/Common/itkBSplineDeformableTransformTest4.png
  )
ENDIF(ITK_USE_OPTIMIZED_REGISTRATION_METHODS)


ADD_TEST(itkOptMattesImageToImageMetricsTest01
  ${REVIEW_TESTS} itkOptMattesMutualInformationImageToImageMetricThreadsTest1

=== debian/changelog ===
insighttoolkit (3.20.0-13ubuntu1) oneiric; urgency=low

  * Set CMAKE_BUILD_TYPE to RelWithDebInfo for non ix86 targets to build
    with -O2, not -O3.
  * Build using binutils-gold on ARM, work-around LP: #641126.
  * Install into dist-packages, not site-packages.
  * Build using dh_python2.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 07 Sep 2011 14:32:21 +2000

insighttoolkit (3.20.0-13) unstable; urgency=low

  * Remove absolute paths to required libraries from
    /usr/lib/InsightToolkit/ITKLibraryDepends.cmake after building,
    closes: #635300.  Due to the multiarch transition, the original
    behavior frequently causes reverse build-deps to FTBFS.  This change
    should probably be reverted once all required libraries are
    multiarched.

 -- Michael Schutte <michi@debian.org>  Tue, 16 Aug 2011 20:52:58 +0200

insighttoolkit (3.20.0-12) unstable; urgency=low

  * patches/itkImageToImageFilterC.patch: Remove.
  * patches/wrap-iifilter-split.patch: New; replaces above patch.  Split
    itkImageToImageFilterB into 3 files, introducing FilterC and FilterD.

 -- Steve M. Robbins <smr@debian.org>  Fri, 12 Aug 2011 20:08:27 -0500

insighttoolkit (3.20.0-11) unstable; urgency=low

  * control: Build-depend on newer gccxml that removes "inline namespace"
    from c++config.h.  Closes: #632582.

 -- Steve M. Robbins <smr@debian.org>  Sun, 24 Jul 2011 00:16:22 -0500

insighttoolkit (3.20.0-10) unstable; urgency=low

  * patches/ptrdiff.patch.  New.  Include <stddef.h> to ensure ptrdiff_t
    is defined.  Closes: #625077, #624941, #625090.
  
  * rules: Enable optimized registration methods and transform IO
    factories.  Closes: #614519.
  
  * patches/tcl-install.patch: Set WRAP_ITK_PACKAGE_DIR to /usr/lib.
    Closes: #618736.
  
  * control: Build-depend on newer gccxml.

 -- Steve M. Robbins <smr@debian.org>  Fri, 06 May 2011 01:31:04 -0500

insighttoolkit (3.20.0-9) unstable; urgency=low

  * control: Build-depend on newer gccxml and cableswig.

 -- Steve M. Robbins <smr@debian.org>  Sun, 06 Mar 2011 15:11:09 -0600

insighttoolkit (3.20.0-8) unstable; urgency=low

  * rules: Remove parallel build.

 -- Steve M. Robbins <smr@debian.org>  Wed, 16 Feb 2011 00:44:55 -0600

insighttoolkit (3.20.0-7) unstable; urgency=low

  * patches/itkImageToImageFilterC.patch: New.  Split the
    ImageToImageFilter into smaller modules to avoid compiler table
    overflow (build failure).
  
  * rules: Try parallel build again.
  
 -- Steve M. Robbins <smr@debian.org>  Sat, 12 Feb 2011 20:04:44 -0600

insighttoolkit (3.20.0-6) unstable; urgency=low

  [Paul Novotny]
  * control:
  * rules:
  * patches/wrapitk-externalprojects.patch: New.  Add two External
    Projects to the WrapITK build. PyBuffer provides easy interoperability
    with numpy. ItkVtkGlue makes it easy to convert from and to VTK.
  
  * rules: Turn off wrapping 4D images, fix wrap setting misspellings.
  
  * patches/add-registration-optimizers.patch: New.  Add a couple new
    registration optimizers, including LBFGSBOptimizer used for B-spline
    3D registration.  Add a few array types to use the optimizers
    correctly.
  
  [Steve Robbins]
  * control: Add build-deps on libvtk5-dev, python-vtk for ItkVtkGlue.
    Remove unnecessary build-deps libjpeg62-dev, libtiff4-dev,
    libfreetype6-dev, libopenjpeg-dev, graphviz, libxext-dev, libxss-dev,
    libxft-dev, libpoppler-dev, libssl-dev.  Closes: #608394.

 -- Steve M. Robbins <smr@debian.org>  Mon, 07 Feb 2011 01:35:06 -0600

insighttoolkit (3.20.0-5) experimental; urgency=low

  * patches/wrapitk.patch: New.  Use ITK_LIBRARY_PROPERTIES to properly
    version libSwigRuntime{Python,Java,Tcl} and the Tcl shared libs (which
    are installed in /usr/lib).

  * rules: Install libSwigJava into /usr/lib.

 -- Steve M. Robbins <smr@debian.org>  Wed, 22 Dec 2010 23:32:20 -0600

insighttoolkit (3.20.0-4) experimental; urgency=low

  * rules: Really remove parallel build (don't set DEB_BUILD_PARALLEL).
  
  * insighttoolkit_3.20.0.orig-review.tar.bz2: New.  Contains contents of
    upstream "Code/Review" directory, heretofore removed from the .orig
    tarball.
  * rules: Build using Review and Review/Statistics.
  
  * rules: Switch from CSWIG wrapping to WrapITK wrapping for java,
    python, and tcl.

 -- Steve M. Robbins <smr@debian.org>  Sun, 19 Dec 2010 22:47:03 -0600

insighttoolkit (3.20.0-3) experimental; urgency=low

  * rules: Remove parallel build; still broken with cswig wrapping.  See
    https://buildd.debian.org/fetch.cgi?pkg=insighttoolkit;ver=3.20.0-1;arch=i386;stamp=1288336939
  
  * control: Bump Standards-Version to 3.9.1.

 -- Steve M. Robbins <smr@debian.org>  Sat, 30 Oct 2010 22:34:32 -0500

insighttoolkit (3.20.0-2) experimental; urgency=low

  * Switch to source package 3.0 (quilt) format.

  * rules: Embed SOVERSION in valgrind suppression files to avoid file
    conflicts on upgrade to new versions of insighttoolkit.  Closes:
    #600867.  Merge from branches/3.18.0
  
  * patches/metaio-test-vtk_source.patch: New.  Upstream fix for build
    error (thanks, Mathieu Malaterre).  Closes: #600677.

 -- Steve M. Robbins <smr@debian.org>  Sat, 30 Oct 2010 16:55:30 -0500

insighttoolkit (3.20.0-1) experimental; urgency=low

  * New upstream.
    - patches/itkTkImageViewer2D.patch: Remove.  Applied upstream.
    - patches/nifti-memleak.patch: Remove.  Applied upstream.

  * control.in: Adjust gccxml version dependency to match what used to be
    in control.

  * rules: Set version variables to 3.20.
  * control: Re-generate for libinsighttoolkit3.20.

  * patches/gccxml-workaround.patch: Remove.  Workaround no longer
    required as gccxml was fixed as of 2008-06-02.

  * rules: Use "make install/fast" to avoid a rebuild at install time.
    Closes: #587184.

  * rules: Enable parallel building (fixed upstream in May).  Closes:
    #578313.

 -- Steve M. Robbins <smr@debian.org>  Wed, 18 Aug 2010 22:03:06 -0500

insighttoolkit (3.18.0-4) unstable; urgency=low



=== debian/control ===
Source: insighttoolkit
Homepage: http://www.itk.org/
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>
Build-Depends: cdbs (>= 0.4.49), debhelper (>= 7), 
 binutils-gold [armel armhf],
 cmake, cableswig (>= 0.1.0+cvs20110226), gccxml (>= 0.9.0+cvs20110723),
 zlib1g-dev (>= 1.2.2), libpng12-dev,
 python-dev, python-numpy, libfftw3-dev,
 tcl8.5-dev, tk8.5-dev, uuid-dev, libgdcm2-dev,
 default-jdk, javahelper (>= 0.18),
 libvtk5-dev, python-vtk
XS-Python-Version: current
Standards-Version: 3.9.1
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/insighttoolkit/trunk/?rev=0&sc=0
Vcs-Svn: svn://svn.debian.org/svn/debian-med/trunk/packages/insighttoolkit/trunk/

Package: libinsighttoolkit3.20
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Image processing toolkit for registration and segmentation - runtime
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the libraries needed to run ITK applications.

Package: libinsighttoolkit3-java
Section: java
Architecture: all
Depends: ${java:Depends}, ${misc:Depends}, libinsighttoolkit3-jni
Description: Image processing toolkit for registration and segmentation - Java bindings
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the Java language bindings for ITK.

Package: libinsighttoolkit3-jni
Section: java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Image processing toolkit for registration and segmentation - JNI
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the Java Native Interface layer used by the java
 language bindings for ITK.

Package: python-insighttoolkit3
Section: python
Architecture: any
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Conflicts: python-insighttoolkit
Replaces: python-insighttoolkit
XB-Python-Version: ${python:Versions}
Description: Image processing toolkit for registration and segmentation - Python bindings
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the Python language bindings for ITK.

Package: tcl8.5-insighttoolkit3
Section: interpreters
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tcl8.5, tk8.5
Conflicts: tcl8.4-insighttoolkit3
Description: Image processing toolkit for registration and segmentation - Tcl bindings
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the Tcl language bindings for ITK.

Package: libinsighttoolkit3-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libinsighttoolkit3.20 (= ${binary:Version})
Recommends: libfftw3-dev, uuid-dev
Conflicts: libinsighttoolkit-dev
Replaces: libinsighttoolkit-dev
Suggests: insighttoolkit3-examples
Description: Image processing toolkit for registration and segmentation - development
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the development files needed to build your own
 ITK applications.

Package: insighttoolkit3-examples
Section: devel
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libinsighttoolkit3-dev
Conflicts: insighttoolkit-examples
Replaces: insighttoolkit-examples
Description: Image processing toolkit for registration and segmentation - examples
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the source for example programs.

=== debian/rules ===
#!/usr/bin/make -f

# If set, honour "parallel=N" option of DEB_BUILD_OPTIONS.  Comment
# out to never build in parallel, regardless of DEB_BUILD_OPTIONS.
#DEB_BUILD_PARALLEL = true

# Using install/fast bypasses the install->all dependency,
# avoiding a complete rebuild by "make install".
# See http://www.itk.org/pipermail/insight-users/2010-August/037827.html
#
# Override variable set in cmake.mk:
DEB_MAKE_INSTALL_TARGET = install/fast DESTDIR=$(DEB_DESTDIR)

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/class/javahelper.mk

VER_MAJOR = 3
VER_MINOR = 20
VER_PATCH = 0

PYVERS = $(shell pyversions -r debian/control)
TCLVERS = 8.5

VER_FULL = $(VER_MAJOR).$(VER_MINOR).$(VER_PATCH)
SOVERSION = $(VER_MAJOR).$(VER_MINOR)

UPSTREAM_SRC = InsightToolkit-$(VER_FULL)
DEBIAN_SRC_DIR = insighttoolkit-$(VER_FULL)
DEBIAN_SRC_TAR = insighttoolkit_$(VER_FULL).orig.tar.gz

pkg_lib = libinsighttoolkit$(SOVERSION)
pkg_dev = libinsighttoolkit$(VER_MAJOR)-dev
pkg_java = libinsighttoolkit$(VER_MAJOR)-java
pkg_jni = libinsighttoolkit$(VER_MAJOR)-jni
pkg_python = python-insighttoolkit$(VER_MAJOR)
pkg_tcl = tcl$(TCLVERS)-insighttoolkit$(VER_MAJOR)
pkg_examples = insighttoolkit$(VER_MAJOR)-examples

JAVA_HOME = /usr/lib/jvm/default-java
JAVA_JNIDIR = /usr/lib/jni

PYMODDIR = usr/lib/$(PYVERS)/dist-packages
PYEXTDIR = $(PYMODDIR)

TCLMODDIR = usr/share/tcltk/tcl$(TCLVERS)/insighttoolkit$(VER_MAJOR)

ifneq (,$(filter $(DEB_HOST_ARCH_CPU), amd64 i386))
  cmake_build_type=RELEASE
else
  cmake_build_type=RelWithDebInfo
endif

DEB_CMAKE_EXTRA_FLAGS = \
	-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
	-DBUILD_EXAMPLES:BOOL=OFF \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_TESTING:BOOL=OFF \
	-DCMAKE_BUILD_TYPE:STRING=$(cmake_build_type) \
	-DBUILD_DOXYGEN:BOOL=OFF \
	-DCMAKE_CXX_FLAGS:STRING=-Wno-deprecated \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DITK_DATA_ROOT:PATH=ITK_DATA_ROOT_NOTFOUND \
	-DITK_USE_REVIEW:BOOL=ON \
	-DITK_USE_REVIEW_STATISTICS:BOOL=ON \
	-DITK_USE_OPTIMIZED_REGISTRATION_METHODS:BOOL=ON \
	-DITK_USE_TRANSFORM_IO_FACTORIES:BOOL=ON \
	-DITK_USE_SYSTEM_GDCM:BOOL=ON \
	-DITK_USE_SYSTEM_JPEG:BOOL=ON \
	-DITK_USE_SYSTEM_PNG:BOOL=ON \
	-DITK_USE_SYSTEM_TIFF:BOOL=ON \
	-DITK_USE_SYSTEM_ZLIB:BOOL=ON \
	-DITK_USE_SYSTEM_VXL:BOOL=OFF \
	-DUSE_FFTWD:BOOL=ON \
	-DUSE_FFTWF:BOOL=ON \
	-DITK_USE_CONCEPT_CHECKING:BOOL=ON \
	-DITK_USE_STRICT_CONCEPT_CHECKING:BOOL=ON \
	-DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/$(PYVERS) \
	-DPYTHON_INCLUDE_PATH:PATH=/usr/include/$(PYVERS) \
	-DPYTHON_NUMPY_INCLUDE_PATH:PATH=/usr/include/$(PYVERS)/numpy \
	-DPYTHON_LIBRARY:FILEPATH=/usr/lib/lib$(PYVERS).so \
	-DTCL_INCLUDE_PATH:PATH=/usr/include/tcl$(TCLVERS) \
	-DTCL_LIBRARY:FILEPATH=/usr/lib/libtcl$(TCLVERS).so \
	-DTCL_TCLSH:FILEPATH=/usr/bin/tclsh$(TCLVERS) \
	-DTK_INCLUDE_PATH:PATH=/usr/include/tcl$(TCLVERS) \
	-DTK_LIBRARY:FILEPATH=/usr/lib/libtk$(TCLVERS).so \
	-DUSE_WRAP_ITK:BOOL=ON \
	-DWRAP_ITK_JAVA:BOOL=ON \
	-DWRAP_ITK_PYTHON:BOOL=ON \
	-DWRAP_ITK_TCL:BOOL=ON \
	-DWRAP_ITK_DIMS:STRING='2;3' \
	-DWRAP_complex_float:BOOL=ON \
	-DWRAP_covariant_vector_float:BOOL=ON \
	-DWRAP_float:BOOL=ON \
	-DWRAP_rgb_unsigned_char:BOOL=ON \
	-DWRAP_rgb_unsigned_short:BOOL=ON \
	-DWRAP_signed_short:BOOL=ON \
	-DWRAP_unsigned_char:BOOL=ON \
	-DWRAP_unsigned_short:BOOL=ON \
	-DWRAP_vector_float:BOOL=ON

pre-build::
	test -d Code/Review || mv review Code/Review

build/$(pkg_dev)::
	sed -i -e "s#/usr/lib/\(`dpkg-architecture -qDEB_HOST_MULTIARCH`/\)\?lib\([^;]*\)\.so#\2#g" \
		$(DEB_BUILDDIR)/ITKLibraryDepends.cmake

common-build-arch::
	echo "$(pkg_tcl): non-dev-pkg-with-shlib-symlink" > debian/$(pkg_tcl).lintian-overrides
	echo "$(pkg_tcl): package-name-doesnt-match-sonames" >> debian/$(pkg_tcl).lintian-overrides
	echo "$(pkg_python): non-dev-pkg-with-shlib-symlink" > debian/$(pkg_python).lintian-overrides
	echo "$(pkg_python): package-name-doesnt-match-sonames" >> debian/$(pkg_python).lintian-overrides
	echo "$(pkg_lib): package-name-doesnt-match-sonames" > debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): embedded-library usr/lib/libitkjpeg8.so.3.20.0: libjpeg" >> debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): embedded-library usr/lib/libitkjpeg12.so.3.20.0: libjpeg" >> debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): embedded-library usr/lib/libitkjpeg16.so.3.20.0: libjpeg" >> debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_lib): embedded-library usr/lib/libitkopenjpeg.so.3.20.0: openjpeg" >> debian/$(pkg_lib).lintian-overrides
	echo "$(pkg_jni): postinst-has-useless-call-to-ldconfig" >> debian/$(pkg_jni).lintian-overrides
	echo "$(pkg_jni): postrm-has-useless-call-to-ldconfig" >> debian/$(pkg_jni).lintian-overrides
	dh_lintian

install/$(pkg_lib)::
	dh_install -p$(pkg_lib) -XJava -XPython -XTcl debian/tmp/usr/lib/InsightToolkit/lib*.so.* usr/lib
	cp CMake/InsightValgrind.supp Insight$(SOVERSION)Valgrind.supp
	cp Utilities/vxl/config/valgrind.supp Insight$(SOVERSION)VxlValgrind.supp
	dh_install -p$(pkg_lib) Insight$(SOVERSION)*.supp usr/lib/valgrind

install/$(pkg_dev)::
	dh_installman -p$(pkg_dev) debian/insighttoolkit.3
	dh_installdocs -p$(pkg_dev) Documentation/*
	dh_install -p$(pkg_dev) -XJava -XPython -XTcl debian/tmp/usr/lib/InsightToolkit/lib*.so usr/lib
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/InsightToolkit/*
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/InsightToolkit/*.cmake 

install/$(pkg_java)::
	jh_installlibs -p$(pkg_java) debian/tmp/usr/lib/InsightToolkit/WrapITK/Java/*.jar

install/$(pkg_jni)::
	dh_install -p$(pkg_jni) -XlibSwig debian/tmp/usr/lib/InsightToolkit/WrapITK/lib/*Java.so* $(JAVA_JNIDIR)
	dh_install -p$(pkg_jni)           debian/tmp/usr/lib/InsightToolkit/WrapITK/lib/libSwigRuntimeJava.so* usr/lib

install/$(pkg_python)::
	dh_install -p$(pkg_python) -XlibSwig debian/tmp/usr/lib/InsightToolkit/WrapITK/lib/*Python.so* $(PYEXTDIR)
	dh_install -p$(pkg_python)           debian/tmp/usr/lib/InsightToolkit/WrapITK/lib/libSwigRuntimePython.so* usr/lib
	dh_install -p$(pkg_python)           debian/tmp/usr/lib/InsightToolkit/WrapITK/Python/* $(PYMODDIR)
	dh_install -p$(pkg_python)           debian/tmp/usr/lib/InsightToolkit/WrapITK/lib/*.py $(PYMODDIR)
	dh_python2 -p$(pkg_python)

install/$(pkg_tcl)::
	dh_install -p$(pkg_tcl) debian/tmp/usr/lib/InsightToolkit/WrapITK/bin/itkwish usr/bin
	dh_install -p$(pkg_tcl) debian/tmp/usr/lib/InsightToolkit/WrapITK/lib/*Tcl.so* usr/lib
	dh_install -p$(pkg_tcl) debian/tmp/usr/lib/InsightToolkit/WrapITK/Tcl/* $(TCLMODDIR)
	dh_installman -p$(pkg_tcl) debian/itkwish.1

install/$(pkg_examples)::
	dh_installexamples -p$(pkg_examples) Examples/*
	find debian/$(pkg_examples)/usr/share/doc/$(pkg_examples)/examples \
	    -type f -print0 | xargs -0 chmod 644

$(UPSTREAM_SRC).tar.gz:
	wget http://voxel.dl.sourceforge.net/sourceforge/itk/$@

get-orig-source: $(UPSTREAM_SRC).tar.gz
	tar xzf $(UPSTREAM_SRC).tar.gz
	find $(UPSTREAM_SRC) -name CVS -o -name Patented | xargs rm -rf
	rm -rf $(UPSTREAM_SRC)/Code/Review
	mv $(UPSTREAM_SRC) $(DEBIAN_SRC_DIR)
	GZIP="--best --no-name" tar czf $(DEBIAN_SRC_TAR) $(DEBIAN_SRC_DIR)

control-file:
	sed -e "s/@VER_MAJOR@/$(VER_MAJOR)/g" \
	    -e "s/@SOVERSION@/$(SOVERSION)/g" \
	    < debian/control.in > debian/control.tmp
	[ -e debian/control ] \
	  && cmp -s debian/control debian/control.tmp \
	  && rm -f debian/control.tmp && exit 0; \
	  mv debian/control.tmp debian/control
